/*	keys.cpp
 *
 *	ITfKeyEventSink	implementation
 *
 *
 *	lȂ΂ȂȂ̂́A
 *		(1) L[Xg[N IME ɓn̂́A̎dȂ̂H
 *		(2)  IME ̏ɈړȂ΂ȂȂ̂H
 *	2_ł낤B(1) 𑁊KvB܂
 *	Ă݂AȂB
 */
#include "globals.h"
#include "skimic.h"
#include "editsess.h"
#include "skkimmgr.h"

class CKeystrokeEditSession : public CEditSessionBase
{
public:
    CKeystrokeEditSession (ITfContext *pContext, WPARAM wParam, LPARAM lParam, CSkkImeMgr* pSkkIme) :
		CEditSessionBase(pContext)
	{
		_wParam 	= wParam ;
		_lParam		= lParam ;
		_pSkkIme	= pSkkIme ;
		return ;
	}
	
    // ITfEditSession
    STDMETHODIMP DoEditSession (TfEditCookie ec) ;
	
private:
    WPARAM		_wParam ;
	LPARAM		_lParam ;
	CSkkImeMgr*	_pSkkIme ;
} ;

#if defined (DEBUG) || defined (_DEBUG)
class CTestSelectionPositionEditSession : public CEditSessionBase 
{
public:
    CTestSelectionPositionEditSession (ITfContext *pContext) :
		CEditSessionBase (pContext)
	{
		_pContext	= pContext ;
		return ;
	}

	STDMETHODIMP DoEditSession (TfEditCookie ec)
	{
		TF_SELECTION		tfSelection ;
		ULONG				cFetched ;
		ITfContextView*		pView = NULL ;
		RECT				rc ;
		BOOL				fClipped ;

		if (_pContext->GetSelection (ec, TF_DEFAULT_SELECTION, 1, &tfSelection, &cFetched) == S_OK && cFetched == 1) {
			if (_pContext->GetActiveView (&pView) == S_OK) {
				if (pView->GetTextExt (ec, tfSelection.range, &rc, &fClipped) == S_OK) {
					DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnKeyDown () - GetTextExt(%d,%d,%d,%d)\n"), rc.left, rc.top, rc.right, rc.bottom)) ;
				}
				pView->Release () ;
			}
			tfSelection.range->Release () ;
		}
		return	S_OK ;
	}
private:
	ITfContext*		_pContext ;
} ;
#endif


/*	_InitKeystrokeSink
 *
 *	Advise a keystroke sink.
 */
BOOL
CSkkImeTextService::_InitKeystrokeSink ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
    HRESULT				hr ;

    if (_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return	FALSE ;

    hr = pKeystrokeMgr->AdviseKeyEventSink(_tfClientId, (ITfKeyEventSink *)this, TRUE);
	
    pKeystrokeMgr->Release () ;

    return	(hr == S_OK) ;
}


/*	_UninitKeystrokeSink
 *
 *	Unadvise a keystroke sink.  Assumes we have advised one already.
 */
void
CSkkImeTextService::_UninitKeystrokeSink ()
{
    ITfKeystrokeMgr *pKeystrokeMgr;

	if (_pThreadMgr == NULL)
		return ;

    if (_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return;

    pKeystrokeMgr->UnadviseKeyEventSink (_tfClientId) ;
    pKeystrokeMgr->Release () ;
}

/*	Hot Key o^B
 *
 *	o^ꂽ Hot Key ꂽǂ OnPreservedKey 
 *	`FbNłB
 */
BOOL
CSkkImeTextService::_InitPreservedKey ()
{
	static LPCWSTR		wstrDesc	= L"Toggle IME" ;
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	TF_PRESERVEDKEY		key ;
	HRESULT				hr ;

	if (_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return	FALSE ;

	/*	register KANJI key */
	key.uVKey		= VK_KANJI ;
	key.uModifiers	= TF_MOD_IGNORE_ALL_MODIFIER ;
	hr	= pKeystrokeMgr->PreserveKey (_tfClientId, c_guidSkkImePreservedKeyToggleIME, &key, wstrDesc, lstrlenW (wstrDesc)) ;
	/*	register ALT+~ key */
	key.uVKey		= 0xC0 ;
	key.uModifiers	= TF_MOD_ALT ;
	hr	= pKeystrokeMgr->PreserveKey (_tfClientId, c_guidSkkImePreservedKeyToggleIME, &key, wstrDesc, lstrlenW (wstrDesc)) ;
    pKeystrokeMgr->Release () ;

	DEBUGPRINTF ((TEXT ("_InitPreservedKey () = %d\n"), (hr == S_OK))) ;
	return	(hr == S_OK) ;
}

/*	_UninitPreservedKey
 *
 *	o^ Hot Key 𖢓o^Ԃɖ߂B
 */
void
CSkkImeTextService::_UninitPreservedKey ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	TF_PRESERVEDKEY		key ;

	if (_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return ;

	key.uVKey		= VK_KANJI ;
	key.uModifiers	= TF_MOD_IGNORE_ALL_MODIFIER ;
	pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyToggleIME, &key) ;
	key.uVKey		= 0xC0 ;
	key.uModifiers	= TF_MOD_ALT ;
	pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyToggleIME, &key) ;
	pKeystrokeMgr->Release () ;
	return ;
}

/*	OnSetFocus
 *
 *	̃T[rX keystroke device focus 𓾂͏ɃVXeɂ
 *	ĂяoB
 *	܂́AꂪAOnTestKeyDown Ă΂oƍlč\Ȃ
 *	낤B
 */
STDAPI
CSkkImeTextService::OnSetFocus (
	BOOL			fForeground)
{
    return	S_OK ;
}

/*	OnTestKeyDown
 *
 *	̃T[rX^ꂽ potential keystroke ~邩ۂ
 *	q˂邽߂ɃVXeɂČĂяoB(A)
 *
 *	ŁAL[Xg[N~AƕԂ΁AOnKeyDown Ăяo
 *	邱ƂɂȂB
 */
STDAPI
CSkkImeTextService::OnTestKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
	int		nEaten ;

	if (_IsKeyboardDisabled ()) {
		*pfEaten	= FALSE ;
		DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (fEaten: %d)\n"), *pfEaten)) ;
		return	S_OK ;
	}

	/*	xkeymacs  foward  event  context bit  1 Ă悤ɎvB
	 *	 key  process Ɣ肷ƁAǂ PowerPoint Ȃǂ \C-x\C-s Ȃǂ
	 *	삪܂Ȃ炵BWord ŔoȂ̂́AWord  context bit 𔻕ʂĂ
	 *	̂낤cH (Wed Feb 15 20:28:29 2006)
	 */
	if (lParam & ((DWORD)1 << 29)) {
		*pfEaten	= FALSE ;
		return	S_OK ;
	}

	/*	IME  Text Service Framework ɂĎ̂ȂA
	 *	ŁAImeSelect ɑ@\ׂł낤B
	 *
	 *	IME ƘAg Text Service ȂA ImeSelect s
	 *	ׂȂ̂H ͗v`FbN낤B
	 */
	nEaten		= _pSkkIme->QueryProcessKey (wParam, lParam) ;
	*pfEaten	= (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) || (nEaten == SKKIME_PROCESS_KEY && _IsKeyboardOpen ()) ;
	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (fEaten: %d)\n"), *pfEaten)) ;
    return	S_OK ;
}

/*	OnKeyDown
 *
 *	Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 *	on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N񋟂邽
 *	ɌĂяoBA*pfEaten == TRUE ŁA OnKeyDown 
 *	oAAvP[V͂̃L[Xg[N
 *	B(ۂɃL[Hׂ邩ǂ̔͒xłAƂ
 *	)
 */
STDAPI
CSkkImeTextService::OnKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    CKeystrokeEditSession*	pEditSession ;
    HRESULT					hr ;
	int						nEaten ;

	hr			= S_FALSE ;
    *pfEaten	= FALSE ;

	/*	VXẽL[ĤׂƂ΁c
	 */
    if (!_pSkkIme || _IsKeyboardDisabled ())
		goto	Exit ;

	nEaten	= _pSkkIme->QueryProcessKey (wParam, lParam) ;
	if (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) {
		ITfKeystrokeMgr*	pKeystrokeMgr	= NULL ;

		if (FAILED (_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr)))
			goto	Exit ;
		hr	= pKeystrokeMgr->SimulatePreservedKey (pContext, c_guidSkkImePreservedKeyToggleIME, pfEaten) ;
		pKeystrokeMgr->Release () ;
	} else if (_IsKeyboardOpen () && nEaten == SKKIME_PROCESS_KEY) {
		HRESULT	hrEaten	= S_FALSE ;

		/*	ۂɕ̃L[Xg[N̂ꏊɁuŁv
		 *	}KvB
		 *	ǂ̕邩́A̎̎BȂA
		 *	IƃL[Xg[N͏ƂɂȂ̂ȁB
		 *
		 *	̑} CKeystrokeEditSession::DoEditSession 
		 *	ǊB
		 */
		pEditSession = new CKeystrokeEditSession (pContext, wParam, lParam, _pSkkIme) ;
        if (pEditSession == NULL) {
            hr	= E_OUTOFMEMORY ;
            goto	Exit ;
        }
		
		/*	u}vȂǂ̏s߂ɂ̓bNK
		 *	v(炵)B=> we need a lock to do our work
		 *
		 *	nb:  method  TF_ES_SYNC tOgƂ legal
		 *		ށAH@Hȏꏊ1łB
		 *	ȂA SYNC AƂƂB
		 */
		hr	= pContext->RequestEditSession(_tfClientId, pEditSession, TF_ES_SYNC | TF_ES_READWRITE, &hrEaten) ;
        if (FAILED (hr)) 
            hrEaten	= S_OK ;
        pEditSession->Release () ;

		/*	̃R[h *pfEaten = FALSE ɂĕԂĂ key 
		 *	handle ĂȂꍇ̂߂ code c
		 *	ƂAhandle ȂłǁH > IE ȂǁB
		 *	̂ŁA*pfEaten = TRUE ɂĂAI keyevent
		 *	Ă݂B
		 *	bZ[W[vȂ悤ɒӁB
		 */
		if (SUCCEEDED (hr) && hrEaten == S_FALSE) {
			INPUT	in ;

			DEBUGPRINTF ((TEXT ("CSkkImeTextService -> SendInput (wVK:0x%x, wScan:0x%x)\n"), wParam, lParam)) ;
			memset (&in, 0, sizeof (in)) ;
			in.type				= INPUT_KEYBOARD ;
			in.ki.wVk			= wParam ;
			in.ki.wScan			= (lParam >> 16) & 0x007F ;
			in.ki.dwFlags		= KEYEVENTF_SCANCODE ;
			in.ki.time			= 0 ;
			in.ki.dwExtraInfo	= NULL ;
			SendInput (1, &in, sizeof (in)) ;
		}
	}
Exit:
    if (hr == S_OK) 
        *pfEaten = TRUE ;

	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnKeyDown (Eaten:%d)\n"), *pfEaten)) ;
#if defined (DEBUG) || defined (_DEBUG)
	{
	    CTestSelectionPositionEditSession*	pEditSession ;
		HRESULT				hrEaten ;

		pEditSession = new CTestSelectionPositionEditSession (pContext) ;
        if (pEditSession == NULL) {
            hr	= E_OUTOFMEMORY ;
        }
		hr	= pContext->RequestEditSession(_tfClientId, pEditSession, TF_ES_SYNC | TF_ES_READ, &hrEaten) ;
		if (FAILED (hr)) {
		}
		pEditSession->Release () ;
	}
#endif
    return S_OK;
}

/*	DoEditSession
 */
STDAPI
CKeystrokeEditSession::DoEditSession (
	TfEditCookie		ec)
{
    WCHAR	wc ;
	BOOL	fEaten	= FALSE ;
	HRESULT	hr ;

	DEBUGPRINTF ((TEXT ("CKeyStrokeEditSession::DoEditSession ()\n"))) ;

	/*	ƂƂ CaseTextService ł́A 
	 *	if (GetKeyState(VK_SHIFT) & 0x8000) {
	 *		// shift-key, make it lowercase
	 *		wc	= (WCHAR)(_wParam | 32) ;
	 *	} else {
	 *		// else make it capital
	 *		wc	= (WCHAR)_wParam ;
	 *	}
	 *	ƂsĂB́AꂽL[
	 *	(ܘ_AplĂ̂A
	 *	ɗ܂łɑ삳Ă)
	 *	 case ϊ̂łB
	 *	nb:	 quick-and-dirty R[hł邪A
	 *		啶 flip 邽߂̐
	 *		@邽߂̃R[hȂA
	 *	AȂقǁB
	 */
	wc	= (WCHAR)_wParam ;
	hr	= _pSkkIme->OnEditSession (_pContext, ec, WM_KEYDOWN, wc, _lParam, &fEaten) ;
	if (FAILED (hr)) {
		DEBUGPRINTF ((TEXT ("_pSkkIme->OnEditSession failed.\n"))) ;
		return	hr ;
	}
	if (hr == S_FALSE) 
		fEaten	= FALSE ;
    return	(fEaten)? S_OK : S_FALSE ;
}

/*	OnTestKeyUp
 *
 *	̃T[rX potentiaon L[Xg[N~邩ǂ
 *	₢킹邽߂ɃVXeɂČĂяoB
 *
 *	 Eaten Ԃ΁A OnKeyUp Ăяo邱
 *	ɂȂBƂAImeProcess ̂悤 KeyUp HׂĂ͂
 *	ƂƂ͖BƂ́Aނ Up/Down 
 *	΂ɂĈȂ΂ȂȂH
 */
STDAPI
CSkkImeTextService::OnTestKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
}

/* OnKeyUp
 *
 * Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 * on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N^邽߂ɌĂяoB
 *	A*pfEaten == TRUE  exit Ȃ΁AAvP[V͂̃L[Xg
 *	[NȂB
 */
STDAPI
CSkkImeTextService::OnKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
}

/*	OnPreservedKey
 *
 *	Called when a hotkey (registered by us, or by the system) is typed.
 *	hotkey  type ꂽɌĂяoB(Ȃق)
 */
STDAPI
CSkkImeTextService::OnPreservedKey (
	ITfContext*		pContext,
	REFGUID			rguid,
	BOOL*			pfEaten)
{
	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnPreservedKey ()\n"))) ;

	/*	CaseTextService ͎̂悤ȃR[hɂȂĂB
	 *	ǂ PreservedKey 𔻒肷ɂ GUID g
	 *	ɂȂ悤B
	 *
	 *	if (IsEqualGUID (rguid, GUID_PRESERVEDKEY_FLIPCASE)) {
	 *		_Menu_FlipDoc (this) ;
	 *		*pfEaten	= TRUE ;
	 *	} else {
	 *		*pfEaten	= FALSE ;
	 *	}
	 *
	 *	Ȃ݂ɁA
	 *	void CCaseTextService::_Menu_FlipKeys(CCaseTextService *_this)
	 *	{
	 *		_this->_fFlipKeys = !_this->_fFlipKeys;
	 *	}
	 *
	 *	 _Menu_FlipKeys ̎ԂłBǂ Menu ̕\
	 *	QƂ郁oϐ𑀍삷邾̂悤B
	 *	j[\̂H!Ƃv̂A̕@
	 *	ŒׂKv邩ȁB
	 */
	/*
	if (IsEqualGUID (rguid, CSkkImeTextService::_GUID_PRESERVEDKEY_TOGGLEIME)) {
		_pSkkIme->SetFilterMode (! _pSkkIme->GetFilterMode ()) ;
		*pfEaten	= TRUE ;
	} else {
		*pfEaten	= FALSE ;
	}
	*/
	if (IsEqualGUID (rguid, c_guidSkkImePreservedKeyToggleIME)) {
		BOOL	fOpen	= _IsKeyboardOpen () ;
		_SetKeyboardOpen (fOpen? FALSE : TRUE) ;
		_pSkkIme->OnKeyboardOpen (!fOpen) ;
		*pfEaten	= TRUE ;
	} else {
		*pfEaten	= FALSE ;
	}
    return	S_OK ;
}

