#include "globals.h"
#include "skimic.h"
#include "skkimmgr.h"
#include "IME\ImeDoc.h"

#define	REGPATH_CICERO	L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.5\\CICERO"

/*	L[{[h{^ GUIDB炭͂̒lňӂɌ肷锤B
 */
const GUID	c_guidKeyboardItemButton	= {
	0x34745C63, 0xB2F0, 0x4784, { 0x8B, 0x67, 0x5E, 0x12, 0xC8, 0x70, 0x1A, 0x31 }
} ;

BOOL
CSkkImeTextService::_InitLangBarItem ()
{
	if (! _InitCModeLangBarItem () ||
		! _InitIMELangBarItem ())
		return	FALSE ;
	return	TRUE ;
}

void
CSkkImeTextService::_UninitLangBarItem ()
{
	_UninitCModeLangBarItem () ;
	_UninitIMELangBarItem () ;
	return ;
}

void
CSkkImeTextService::_UpdateLangBarItem (
	REFGUID			rguid)
{
	if (IsEqualGUID (rguid, c_guidConversionModeItemButton)) {
		_UpdateCModeLangBarItem () ;
	} else if (IsEqualGUID (rguid, c_guidToolItemButton)) {
		_UpdateIMELangBarItem () ;
	}
	return ;
}

void
CSkkImeTextService::_UpdateLangBarItem ()
{
	ITfLangBarItemMgr*				pLangBarItemMgr	= NULL ;
	ITfLangBarItem*					pItem ;
	//ITfSystemLangBarItem*			pSysItem ;
	ITfSystemDeviceTypeLangBarItem*	pSysDevItem ;

	/*	L[{[hACR̕\Rg[B*/
	if (_pThreadMgr->QueryInterface (IID_ITfLangBarItemMgr, (void**)&pLangBarItemMgr) != S_OK) 
		return ;

	if (pLangBarItemMgr->GetItem (c_guidKeyboardItemButton, &pItem) == S_OK) {
		if (_IsShowLangBarItem (REGKEY_SHOWKEYBRDICON)) {
			if (SUCCEEDED (pItem->QueryInterface (IID_ITfSystemDeviceTypeLangBarItem, (void**)&pSysDevItem)) && pSysDevItem != NULL) {
				pSysDevItem->SetIconMode (0) ;
				pSysDevItem->Release () ;
			}

			/*	ɗƂƂ IME ƓĂƂ
			 *	Ȃ̂ŃL[{[hACR̓L[{[ȟ`Ă锤
			 *	łB
			 *	̃R[h͕svB(L[{[hACRʂ̂ɕύX
			 *	Ƃꍇɂ͗Lɂ邱Ƃ邩)
			 */
#if 0
			if (SUCCEEDED (pItem->QueryInterface (IID_ITfSystemLangBarItem, (void**)&pSysItem)) && pSysItem != NULL) {
				register HICON	hIcon ;

				hIcon	= (HICON) LoadImage (g_hInst, TEXT ("IDI_KEYBRD"), IMAGE_ICON, 16, 16, 0) ;
				if (hIcon != NULL) 
					pSysItem->SetIcon (hIcon) ;
				pSysItem->Release () ;
			}
#endif
			pItem->Show (TRUE) ;
		} else {
			pItem->Show (FALSE) ;
		}
		pItem->Release () ;
	}
	pLangBarItemMgr->Release () ;

	/*	cB*/
	_UpdateCModeLangBarItem () ;
	_UpdateIMELangBarItem () ;
	return ;
}

void
CSkkImeTextService::_SetConversionMode (int nMode)
{
	CImeDoc*	pDoc ;
	BOOL		fUpdate	= FALSE ;

	if (_pSkkIme == NULL)
		return ;
	pDoc	= _pSkkIme->GetDocument () ;
	if (pDoc == NULL)
		return ;

	if (! _IsKeyboardOpen ()) {
		if (SUCCEEDED (_SetKeyboardOpen (TRUE)))
			fUpdate	= TRUE ;
	}
	if (pDoc->bSetConversionMode (nMode)) 
		fUpdate	= TRUE ;
	if (fUpdate)
		_UpdateCModeLangBarItem () ;
	return ;
}

CSkkImeMgr*
CSkkImeTextService::_GetCurrentIME ()
{
	return	_pSkkIme ;
}

void
CSkkImeTextService::_Menu_ToHiragana (
	CSkkImeTextService*		pSkkIme)
{
	pSkkIme->_SetConversionMode (IMECMODE_HIRAGANA) ;
	return ;
}

void
CSkkImeTextService::_Menu_ToZenkata (
	CSkkImeTextService*		pSkkIme)
{
	pSkkIme->_SetConversionMode (IMECMODE_KATAKANA) ;
	return ;
}

void
CSkkImeTextService::_Menu_ToZenei (
	CSkkImeTextService*		pSkkIme)
{
	pSkkIme->_SetConversionMode (IMECMODE_ZENKAKU) ;
	return ;
}

void
CSkkImeTextService::_Menu_ToHankata (
	CSkkImeTextService*		pSkkIme)
{
	pSkkIme->_SetConversionMode (IMECMODE_HANKANA) ;
	return ;
}

void
CSkkImeTextService::_Menu_ToHanei (
	CSkkImeTextService*		pSkkIme)
{
	pSkkIme->_SetConversionMode (IMECMODE_ASCII) ;
	return ;
}

void
CSkkImeTextService::_Menu_ToDirect (
	CSkkImeTextService*		pSkkIme)
{
	CSkkImeMgr*	pImeMgr ;
	BOOL		fUpdate	= FALSE ;

	pImeMgr	= pSkkIme->_GetCurrentIME () ;
	if (pImeMgr == NULL)
		return ;

	if (pSkkIme->_IsKeyboardOpen ()) {
		pSkkIme->_SetKeyboardOpen (FALSE) ;
		fUpdate	= TRUE ;
#if 0
		ITfDocumentMgr*	pFocusDoc	= NULL ;

		if (pSkkIme->_pThreadMgr == NULL)
			return ;
		if (pSkkIme->_pThreadMgr->GetFocus (&pFocusDoc) == S_OK) {
			ITfContext*	pContext	= NULL ;

			if (pFocusDoc->GetTop (&pContext) == S_OK) {
				pSkkIme->_TerminateCompositionInContext (pContext) ;
				pImeMgr->SetFilterMode (FALSE) ;
				fUpdate	= TRUE ;
			}
			pContext->Release () ;
		}
		pFocusDoc->Release () ;
#endif
	}
	if (fUpdate)
		pSkkIme->_UpdateCModeLangBarItem () ;
	return ;
}

DWORD
CSkkImeTextService::_Menu_GetNormalFlag (
	CSkkImeTextService*		pSkkIme)
{
	return 	(pSkkIme->_IsKeyboardDisabled ())? TF_LBMENUF_GRAYED : 0 ;
}

DWORD
CSkkImeTextService::_Menu_GetToggleKeyboardFlag (
	CSkkImeTextService*		pSkkIme)
{
	return	pSkkIme->_IsShowLangBarItem (REGKEY_SHOWKEYBRDICON)? TF_LBMENUF_CHECKED : 0 ;
}

void
CSkkImeTextService::_Menu_Help (
	CSkkImeTextService*		pThis)
{
	return ;
}

void
CSkkImeTextService::_Menu_Property (
	CSkkImeTextService*		pThis)
{
	int		nRetval ;

	if (pThis == NULL)
		return ;
	pThis->Show (NULL, SKKIME_LANGID, c_guidSkkImeProfile) ;	/* ̌Ăяoŗǂ̂H */
	return ;
}

void
CSkkImeTextService::_Menu_Reconversion (
	CSkkImeTextService*		pSkkIme)
{
	return ;
}

void
CSkkImeTextService::_Menu_ToggleShowKeyboard (
	CSkkImeTextService*		pSkkIme)
{
	DWORD	dwValue, dwDisposition, dwRetval ;
	HKEY	hKey ;

	if (pSkkIme == NULL)
		return ;

	dwValue	= pSkkIme->_IsShowLangBarItem (REGKEY_SHOWKEYBRDICON)? 0L : 1L ;

	if (RegCreateKeyExW (HKEY_CURRENT_USER, REGPATH_CICERO, 0, 0, REG_OPTION_NON_VOLATILE, KEY_WRITE, 0, &hKey, &dwDisposition) != ERROR_SUCCESS)
		return ;
	dwRetval = RegSetValueExW (hKey, REGKEY_SHOWKEYBRDICON, 0, REG_DWORD, (CONST BYTE *)&dwValue, sizeof(DWORD)) ;
	RegCloseKey (hKey) ;
	if (dwRetval == ERROR_SUCCESS)
		pSkkIme->_UpdateLangBarItem () ;
	return ;
}

BOOL
CSkkImeTextService::_IsShowLangBarItem (
	LPCWSTR		wstrKey)
{
	HKEY		hSubKey ;
	LONG		lResult ;
	BOOL		fShow ;

	fShow	= TRUE ;
	lResult = RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_CICERO, 0, KEY_READ, &hSubKey) ;
	if (lResult == ERROR_SUCCESS) {
		DWORD			dwValue, cbData, dwType ;
		
		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, wstrKey, NULL, &dwType, (LPBYTE) &dwValue, &cbData) == ERROR_SUCCESS && dwType == REG_DWORD) 
			fShow = (dwValue != 0) ;
		RegCloseKey (hSubKey) ;
	}
	return	fShow ;
}


